/* Plugin: CPU Stat 
 * File: plugin.cpp
 * Author: Prodigy (jcouzens@uhfco.net)
 * Date: April 21, 2003
 * Info: heart of the plugin, some helper functions
*/

#include <extdll.h>		//always
#include <string.h>  	//to prevent linux errors while processing meta_api.h
#include <meta_api.h>
#include <sdk_util.h>	//pre-defined function definitions saves us a lot of work
#include <cbase.h>
#include <player.h>
#include "plugin.h"
#include "servercommands.h"

float fLastDisplayTime = 0.0f;
float myPlayerArray[32];

// Number of CPU's
cvar_t cpustat_numcpu = {"cpustat_numcpu", "1", FCVAR_ARCHIVE, 0, NULL};

// /cpu command default password
cvar_t cpustat_passwd = {"cpustat_passwd", "modns", FCVAR_ARCHIVE, 0, NULL};

// set display type pretty (0) or console (1)
cvar_t cpustat_display = {"cpustat_display", "0", FCVAR_ARCHIVE, 0, NULL};

#ifdef WITH_NS
// Frequency to announce stat to (for ns)
cvar_t cpustat_freq = {"cpustat_freq", "6", FCVAR_ARCHIVE, 0, NULL};
#else
// Frequency to announce stat to (for all other mods)
cvar_t cpustat_freq = {"cpustat_freq", "1", FCVAR_ARCHIVE, 0, NULL};
#endif


//=================================================================
//the grand old initialization function
//=================================================================
void plugin_init(void)
{

// Plugin startup.  Register commands and cvars.
	unsigned i;

	for(i=0; i < (sizeof(myPlayerArray)/sizeof(myPlayerArray[0])); i++)
	{
		myPlayerArray[i] = 0.0f;
	}

	CVAR_REGISTER(&cpustat_freq);
	CVAR_REGISTER(&cpustat_passwd);
	CVAR_REGISTER(&cpustat_numcpu);
	CVAR_REGISTER(&cpustat_display);

	REG_SVR_COMMAND("cpuStat",&cpuStat);
	
	UTIL_LogPrintf( "[" MY_LOGTAG "] ===============LOADING==============\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] By Prodigy (jcouzens@uhfco.net)\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] Version: %s\n", MY_VERSION);
	UTIL_LogPrintf( "[" MY_LOGTAG "] ===============LOADING==============\n");
}


//=================================================================
//the grand old quit function
//=================================================================
void plugin_quit(void)
{
	UTIL_LogPrintf( "[" MY_LOGTAG "] ==============UNLOADING=============\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] By Prodigy (jcouzens@uhfco.net)\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] Version: %s\n", MY_VERSION);
	UTIL_LogPrintf( "[" MY_LOGTAG "] ==============UNLOADING=============\n");
}


//=================================================================
//helper functions
//=================================================================
float strtofloat( const char *szStringToConvert )
{
	int counter = 0;
	float returnval = 0;
	bool isnegative = false;
	if(szStringToConvert[0] == '-')
	{
		isnegative = true;
		counter++;
	}
	if(szStringToConvert[0] == '+')
	{
		counter++;
	}
	while(szStringToConvert[counter] >= '0' && szStringToConvert[counter] <= '9' || 
	szStringToConvert[counter] == '.')
	{
		if(szStringToConvert[counter] != '.')
		{
			returnval *= 10;
			returnval += szStringToConvert[counter] - '0';
		}
		else
		{
			counter++;
			float multiple = 1.0;
			while(szStringToConvert[counter] >= '0' && szStringToConvert[counter] <= '9')
			{
				multiple /= 10;
				returnval += (szStringToConvert[counter] - '0') * multiple;
				counter++;
			}			
		}
		counter++;
	}
	if(isnegative) returnval *= -1;
	return returnval;
}

int strtoint( const char *szStringToConvert )
{
	int counter = 0;
	int returnval = 0;
	bool isnegative = false;
	if(szStringToConvert[0] == '-')
	{
		isnegative = true;
		counter++;
	}
	if(szStringToConvert[0] == '+')
	{
		counter++;
	}
	while(szStringToConvert[counter] >= '0' && szStringToConvert[counter] <= '9')
	{
		returnval *= 10;
		returnval += szStringToConvert[counter] - '0';
		counter++;
	}
	
	if(isnegative) returnval *= -1;
	
	return returnval;
}
